<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: Transform Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('structTransform.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="structTransform-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Transform Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Image Processing Transforms.  
 <a href="structTransform.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Transforms_8h_source.html">Transforms.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a79935b0501625a704e52d91f08c53f96"><td class="memItemLeft" align="right" valign="top"><a id="a79935b0501625a704e52d91f08c53f96"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a79935b0501625a704e52d91f08c53f96">getDescription</a> ()</td></tr>
<tr class="memdesc:a79935b0501625a704e52d91f08c53f96"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get description of processing engine. <br /></td></tr>
<tr class="separator:a79935b0501625a704e52d91f08c53f96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91c6da0b9e8ec35414e79ef6e7af0433"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a91c6da0b9e8ec35414e79ef6e7af0433">normalize</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, const std::vector&lt; float &gt; &amp;max, const std::vector&lt; float &gt; &amp;min)</td></tr>
<tr class="memdesc:a91c6da0b9e8ec35414e79ef6e7af0433"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to create normalized array.  <a href="#a91c6da0b9e8ec35414e79ef6e7af0433">More...</a><br /></td></tr>
<tr class="separator:a91c6da0b9e8ec35414e79ef6e7af0433"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a457a557dfab93e25e4745f64937862f5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a457a557dfab93e25e4745f64937862f5">cmap</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, enum cmap_type cmap)</td></tr>
<tr class="memdesc:a457a557dfab93e25e4745f64937862f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to apply colormap to gray images.  <a href="#a457a557dfab93e25e4745f64937862f5">More...</a><br /></td></tr>
<tr class="separator:a457a557dfab93e25e4745f64937862f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b70af250f14cf171f980b2a32c63d09"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a0b70af250f14cf171f980b2a32c63d09">inv</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in)</td></tr>
<tr class="memdesc:a0b70af250f14cf171f980b2a32c63d09"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to invert colormaps.  <a href="#a0b70af250f14cf171f980b2a32c63d09">More...</a><br /></td></tr>
<tr class="separator:a0b70af250f14cf171f980b2a32c63d09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec3ef98eb69767a1b3f563cf4ee9694e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#aec3ef98eb69767a1b3f563cf4ee9694e">shade</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, int h_angle, int v_angle)</td></tr>
<tr class="memdesc:aec3ef98eb69767a1b3f563cf4ee9694e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Hillshading function to simulate raking light images.  <a href="#aec3ef98eb69767a1b3f563cf4ee9694e">More...</a><br /></td></tr>
<tr class="separator:aec3ef98eb69767a1b3f563cf4ee9694e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b709fc6b2e17c8517091750e41d1c21"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a1b709fc6b2e17c8517091750e41d1c21">LAB2sRGB</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in)</td></tr>
<tr class="memdesc:a1b709fc6b2e17c8517091750e41d1c21"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert from CIELAB to sRGB colour space.  <a href="#a1b709fc6b2e17c8517091750e41d1c21">More...</a><br /></td></tr>
<tr class="separator:a1b709fc6b2e17c8517091750e41d1c21"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef17ac45981f521367b5b84292c09df8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#aef17ac45981f521367b5b84292c09df8">contrast</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, float c)</td></tr>
<tr class="memdesc:aef17ac45981f521367b5b84292c09df8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function to apply a contrast adjustment and clip to 8 bit.  <a href="#aef17ac45981f521367b5b84292c09df8">More...</a><br /></td></tr>
<tr class="separator:aef17ac45981f521367b5b84292c09df8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3dff2adee439080e103922910f01e107"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a3dff2adee439080e103922910f01e107">gamma</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, float g)</td></tr>
<tr class="memdesc:a3dff2adee439080e103922910f01e107"><td class="mdescLeft">&#160;</td><td class="mdescRight">Apply a gamma correction.  <a href="#a3dff2adee439080e103922910f01e107">More...</a><br /></td></tr>
<tr class="separator:a3dff2adee439080e103922910f01e107"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae57c6a03ac48bc1956ff8d384e6afead"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#ae57c6a03ac48bc1956ff8d384e6afead">interpolate_nearestneighbour</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, unsigned int w, unsigned int h)</td></tr>
<tr class="memdesc:ae57c6a03ac48bc1956ff8d384e6afead"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resize image using nearest neighbour interpolation.  <a href="#ae57c6a03ac48bc1956ff8d384e6afead">More...</a><br /></td></tr>
<tr class="separator:ae57c6a03ac48bc1956ff8d384e6afead"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7e5551efe57aef7a3f3f1ee6d8b766f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#ae7e5551efe57aef7a3f3f1ee6d8b766f">interpolate_bilinear</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, unsigned int w, unsigned int h)</td></tr>
<tr class="memdesc:ae7e5551efe57aef7a3f3f1ee6d8b766f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resize image using bilinear interpolation.  <a href="#ae7e5551efe57aef7a3f3f1ee6d8b766f">More...</a><br /></td></tr>
<tr class="separator:ae7e5551efe57aef7a3f3f1ee6d8b766f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a526efb8dbfcca9d29890a791e212c30e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a526efb8dbfcca9d29890a791e212c30e">rotate</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, float angle)</td></tr>
<tr class="memdesc:a526efb8dbfcca9d29890a791e212c30e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Rotate image - currently only by 90, 180 or 270 degrees, other values will do nothing.  <a href="#a526efb8dbfcca9d29890a791e212c30e">More...</a><br /></td></tr>
<tr class="separator:a526efb8dbfcca9d29890a791e212c30e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b23b4901c60d29e17069a60aa796c4c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a9b23b4901c60d29e17069a60aa796c4c">greyscale</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in)</td></tr>
<tr class="memdesc:a9b23b4901c60d29e17069a60aa796c4c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert image to grayscale.  <a href="#a9b23b4901c60d29e17069a60aa796c4c">More...</a><br /></td></tr>
<tr class="separator:a9b23b4901c60d29e17069a60aa796c4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a406c76986276c32665d6a5b16d978c32"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a406c76986276c32665d6a5b16d978c32">twist</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, const std::vector&lt; std::vector&lt; float &gt; &gt; &amp;ctw)</td></tr>
<tr class="memdesc:a406c76986276c32665d6a5b16d978c32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Apply a color twist.  <a href="#a406c76986276c32665d6a5b16d978c32">More...</a><br /></td></tr>
<tr class="separator:a406c76986276c32665d6a5b16d978c32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaf78ed0c7e79553ccf6edc34b3223db0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#aaf78ed0c7e79553ccf6edc34b3223db0">flatten</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, int bands)</td></tr>
<tr class="memdesc:aaf78ed0c7e79553ccf6edc34b3223db0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Extract bands.  <a href="#aaf78ed0c7e79553ccf6edc34b3223db0">More...</a><br /></td></tr>
<tr class="separator:aaf78ed0c7e79553ccf6edc34b3223db0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac63c2058b3bfe1a896730e69bde3a8c5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#ac63c2058b3bfe1a896730e69bde3a8c5">flip</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, int o)</td></tr>
<tr class="memdesc:ac63c2058b3bfe1a896730e69bde3a8c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flip image.  <a href="#ac63c2058b3bfe1a896730e69bde3a8c5">More...</a><br /></td></tr>
<tr class="separator:ac63c2058b3bfe1a896730e69bde3a8c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6c829f0bb60037219b2fbdc1e6523a2"><td class="memItemLeft" align="right" valign="top">std::vector&lt; unsigned int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#aa6c829f0bb60037219b2fbdc1e6523a2">histogram</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, const std::vector&lt; float &gt; &amp;max, const std::vector&lt; float &gt; &amp;min)</td></tr>
<tr class="memdesc:aa6c829f0bb60037219b2fbdc1e6523a2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate histogram of an image.  <a href="#aa6c829f0bb60037219b2fbdc1e6523a2">More...</a><br /></td></tr>
<tr class="separator:aa6c829f0bb60037219b2fbdc1e6523a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a35876de0838e52cf8489ca9d71dfb7f5"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a35876de0838e52cf8489ca9d71dfb7f5">threshold</a> (std::vector&lt; unsigned int &gt; &amp;<a class="el" href="structTransform.html#aa6c829f0bb60037219b2fbdc1e6523a2">histogram</a>)</td></tr>
<tr class="memdesc:a35876de0838e52cf8489ca9d71dfb7f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Calculate threshold for binary (bi-level) segmentation.  <a href="#a35876de0838e52cf8489ca9d71dfb7f5">More...</a><br /></td></tr>
<tr class="separator:a35876de0838e52cf8489ca9d71dfb7f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ac1decab1c97287baff8b1078a0af8d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#a3ac1decab1c97287baff8b1078a0af8d">binary</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, unsigned char <a class="el" href="structTransform.html#a35876de0838e52cf8489ca9d71dfb7f5">threshold</a>)</td></tr>
<tr class="memdesc:a3ac1decab1c97287baff8b1078a0af8d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create binary (bi-level) image.  <a href="#a3ac1decab1c97287baff8b1078a0af8d">More...</a><br /></td></tr>
<tr class="separator:a3ac1decab1c97287baff8b1078a0af8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afec763854d9c1014b228db409089a394"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structTransform.html#afec763854d9c1014b228db409089a394">equalize</a> (<a class="el" href="classRawTile.html">RawTile</a> &amp;in, std::vector&lt; unsigned int &gt; &amp;<a class="el" href="structTransform.html#aa6c829f0bb60037219b2fbdc1e6523a2">histogram</a>)</td></tr>
<tr class="memdesc:afec763854d9c1014b228db409089a394"><td class="mdescLeft">&#160;</td><td class="mdescRight">Apply histogram equalization to an image.  <a href="#afec763854d9c1014b228db409089a394">More...</a><br /></td></tr>
<tr class="separator:afec763854d9c1014b228db409089a394"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Image Processing Transforms. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a3ac1decab1c97287baff8b1078a0af8d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ac1decab1c97287baff8b1078a0af8d">&#9670;&nbsp;</a></span>binary()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::binary </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char&#160;</td>
          <td class="paramname"><em>threshold</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create binary (bi-level) image. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">threshold</td><td>threshold for binary image segmentation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a457a557dfab93e25e4745f64937862f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a457a557dfab93e25e4745f64937862f5">&#9670;&nbsp;</a></span>cmap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::cmap </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">enum cmap_type&#160;</td>
          <td class="paramname"><em>cmap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to apply colormap to gray images. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile data to be converted </td></tr>
    <tr><td class="paramname">cmap</td><td>color map to apply. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aef17ac45981f521367b5b84292c09df8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef17ac45981f521367b5b84292c09df8">&#9670;&nbsp;</a></span>contrast()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::contrast </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>c</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to apply a contrast adjustment and clip to 8 bit. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile data to be adjusted </td></tr>
    <tr><td class="paramname">c</td><td>contrast value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="afec763854d9c1014b228db409089a394"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afec763854d9c1014b228db409089a394">&#9670;&nbsp;</a></span>equalize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::equalize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; unsigned int &gt; &amp;&#160;</td>
          <td class="paramname"><em>histogram</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Apply histogram equalization to an image. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">histogram</td><td>image histogram </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aaf78ed0c7e79553ccf6edc34b3223db0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaf78ed0c7e79553ccf6edc34b3223db0">&#9670;&nbsp;</a></span>flatten()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::flatten </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>bands</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Extract bands. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">bands</td><td>number of bands </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac63c2058b3bfe1a896730e69bde3a8c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac63c2058b3bfe1a896730e69bde3a8c5">&#9670;&nbsp;</a></span>flip()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::flip </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>o</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flip image. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">o</td><td>orientation (0=horizontal,1=vertical) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a3dff2adee439080e103922910f01e107"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dff2adee439080e103922910f01e107">&#9670;&nbsp;</a></span>gamma()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::gamma </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>g</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Apply a gamma correction. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile input data </td></tr>
    <tr><td class="paramname">g</td><td>gamma </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9b23b4901c60d29e17069a60aa796c4c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b23b4901c60d29e17069a60aa796c4c">&#9670;&nbsp;</a></span>greyscale()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::greyscale </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert image to grayscale. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa6c829f0bb60037219b2fbdc1e6523a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa6c829f0bb60037219b2fbdc1e6523a2">&#9670;&nbsp;</a></span>histogram()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;unsigned int&gt; Transform::histogram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; float &gt; &amp;&#160;</td>
          <td class="paramname"><em>max</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; float &gt; &amp;&#160;</td>
          <td class="paramname"><em>min</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculate histogram of an image. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">max</td><td>max image values for each channel </td></tr>
    <tr><td class="paramname">min</td><td>min image values for each channel </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>vector containing histogram (single histogram for all channels) </dd></dl>

</div>
</div>
<a id="ae7e5551efe57aef7a3f3f1ee6d8b766f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7e5551efe57aef7a3f3f1ee6d8b766f">&#9670;&nbsp;</a></span>interpolate_bilinear()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::interpolate_bilinear </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>w</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>h</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Resize image using bilinear interpolation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile input data </td></tr>
    <tr><td class="paramname">w</td><td>target width </td></tr>
    <tr><td class="paramname">h</td><td>target height </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae57c6a03ac48bc1956ff8d384e6afead"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae57c6a03ac48bc1956ff8d384e6afead">&#9670;&nbsp;</a></span>interpolate_nearestneighbour()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::interpolate_nearestneighbour </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>w</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>h</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Resize image using nearest neighbour interpolation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile input data </td></tr>
    <tr><td class="paramname">w</td><td>target width </td></tr>
    <tr><td class="paramname">h</td><td>target height </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a0b70af250f14cf171f980b2a32c63d09"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b70af250f14cf171f980b2a32c63d09">&#9670;&nbsp;</a></span>inv()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::inv </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to invert colormaps. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile data to be adjusted </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1b709fc6b2e17c8517091750e41d1c21"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1b709fc6b2e17c8517091750e41d1c21">&#9670;&nbsp;</a></span>LAB2sRGB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::LAB2sRGB </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert from CIELAB to sRGB colour space. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile data to be converted </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a91c6da0b9e8ec35414e79ef6e7af0433"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a91c6da0b9e8ec35414e79ef6e7af0433">&#9670;&nbsp;</a></span>normalize()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::normalize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; float &gt; &amp;&#160;</td>
          <td class="paramname"><em>max</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; float &gt; &amp;&#160;</td>
          <td class="paramname"><em>min</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function to create normalized array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile data to be adjusted </td></tr>
    <tr><td class="paramname">min</td><td>: vector of minima </td></tr>
    <tr><td class="paramname">max</td><td>: vector of maxima </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a526efb8dbfcca9d29890a791e212c30e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a526efb8dbfcca9d29890a791e212c30e">&#9670;&nbsp;</a></span>rotate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::rotate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>angle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Rotate image - currently only by 90, 180 or 270 degrees, other values will do nothing. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile input data </td></tr>
    <tr><td class="paramname">angle</td><td>angle of rotation - currently only rotations by 90, 180 and 270 degrees are suported, for other values, no rotation will occur </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aec3ef98eb69767a1b3f563cf4ee9694e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aec3ef98eb69767a1b3f563cf4ee9694e">&#9670;&nbsp;</a></span>shade()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::shade </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>h_angle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v_angle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Hillshading function to simulate raking light images. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>tile input data containing normal vectors at each point </td></tr>
    <tr><td class="paramname">h_angle</td><td>angle in the horizontal plane from 12 o'clock in degrees </td></tr>
    <tr><td class="paramname">v_angle</td><td>angle in the vertical plane in degrees. 0 is flat, 90 pointing directly down. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a35876de0838e52cf8489ca9d71dfb7f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a35876de0838e52cf8489ca9d71dfb7f5">&#9670;&nbsp;</a></span>threshold()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char Transform::threshold </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; unsigned int &gt; &amp;&#160;</td>
          <td class="paramname"><em>histogram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Calculate threshold for binary (bi-level) segmentation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">histogram</td><td>image histogram </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>threshold </dd></dl>

</div>
</div>
<a id="a406c76986276c32665d6a5b16d978c32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a406c76986276c32665d6a5b16d978c32">&#9670;&nbsp;</a></span>twist()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Transform::twist </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classRawTile.html">RawTile</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; float &gt; &gt; &amp;&#160;</td>
          <td class="paramname"><em>ctw</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Apply a color twist. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">in</td><td>input image </td></tr>
    <tr><td class="paramname">ctw</td><td>2D color twist matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="Transforms_8h_source.html">Transforms.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="structTransform.html">Transform</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
